<template>
	<div>
		<v-snackbar v-model="snack" :timeout="timeout" top color="blue">Carrera agregada</v-snackbar>
		<v-dialog v-model="visibleForm" persistent max-width="550">
			<v-card>
				<v-card-title>
					Agregar carrera para {{ institute }}
				</v-card-title>
				<v-card-text>
					<v-row justify="space-around">
						<v-col cols="12" sm="9">
							<v-text-field label="Ingresa la carrera" outlined v-model="career" />
						</v-col>
						<v-col cols="12" sm="3">
							<v-text-field type="number" label="Valor" v-model="value" outlined min="0" @keydown.enter="addCareer" />
						</v-col>
					</v-row>
					<v-row justify="center">
						<v-col cols="12" sm="4">
							<v-btn :loading="loading" color="green" block outlined @click="addCareer">
								Agregar
								<template v-slot:loader>
									<span>Guardando...</span>
								</template>
							</v-btn>
						</v-col>
						<v-col cols="12" sm="4">
							<v-btn color="red" block outlined @click="closeFormNewCareer">Cerrar</v-btn>
						</v-col>
					</v-row>
				</v-card-text>
			</v-card>
		</v-dialog>
	</div>
</template>

<script>
import EventBus from "../../bus";
import gql from "graphql-tag";

export default {
	name: "FormNewCareer",
	props: ["visibleForm", "institute"],
	data: () => ({
		snack: false,
		timeout: 3000,
		career: "",
		value: 0,
		loading: false
	}),
	methods: {
		// Agregra una nueva carrera
		async addCareer() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$institute: String!
							$career: String!
							$value: Int!
						) {
							addCareer(
								institute: $institute
								career: $career
								value: $value
							)
						}
					`,
					variables: {
						institute: this.institute,
						career: this.career,
						value: parseInt(this.value, 10)
					}
				});
				this.loading = true;
				setTimeout(() => {
					this.loading = false;
					this.snack = true;
					this.value = 0;
					this.career = "";
				}, 2000);
			} catch (error) {}
		},
		// cierra el formulario
		closeFormNewCareer() {
			EventBus.$emit("closeFormNewCareer");
		}
	},
	mounted() {
		// cierra el formulario de nueva carrera
		document.addEventListener("keydown", event => {
			const keyWhich = event.which;
			if (keyWhich == 27) {
				this.closeFormNewCareer();
			}
		});
	}
};
</script>